package Bluestem;
use strict;
use warnings;

use Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(
	bluestem_login bluestem_logout bluestem_id bluestem_id_parse
	bluestem_id_short bluestem_id_full bluestem_log bluestem_random
);

use CGI ();
use Bluestem::CGIClient ();
my $cgi = CGI->new();
my $bsc = Bluestem::CGIClient->new( cgi => $cgi );

our $C_Version = $Bluestem::Client::BSVERSION;
our $C_CacheDir = $bsc->{conf}{cache_dir};
our $C_ImgPath = $bsc->{conf}{imgpath};
our $C_NT = $bsc->{conf}{is_iis};
our $C_AppServerAdminEmail = $bsc->{conf}{admin_email} || 'consult@uic.edu';
our $C_DefaultDomain = $bsc->{conf}{default_domain};
our $C_DefaultAuth = $bsc->{conf}{default_auth};
our $C_DocConf = $bsc->{conf}{doc_conf};
our $R_ServerNamePort = $bsc->{conf}{servername};
our $R_ServerNamePortCookie = $R_ServerNamePort;
our $R_Client = $ENV{REMOTE_HOST};
our $R_ClientIP = $ENV{REMOTE_ADDR};
our $R_PathInfo = $ENV{PATH_INFO} || '';
our $R_ScriptName = $ENV{SCRIPT_NAME} || $cgi->url('-absolute'=>1);
our $R_MyURL = "https://$R_ServerNamePort$R_ScriptName$R_PathInfo";
$R_MyURL .= "?$ENV{'QUERY_STRING'}" if $ENV{'QUERY_STRING'};
$R_ServerNamePortCookie =~ tr/:/_/;

sub bluestem_login
{
	my($return_url, $msg, $prior, $debug) = @_;
	$bsc->handle_login(
		return_url => $return_url,
		message => $msg,
		prior => $prior
	);
	exit 0;
}

sub bluestem_logout
{
	my($debug) = @_;
	$bsc->end_session();
}

sub bluestem_id
{
	my $session = $bsc->get_session()
		or return;
	return(
		$bsc->bluestem_id_short($session->{netid}),
		$session->{idle},
		$session->{age}
	);
}

sub bluestem_id_parse { $bsc->bluestem_id_parse(@_) }
sub bluestem_id_short { $bsc->bluestem_id_short(@_) }
sub bluestem_id_full  { $bsc->bluestem_id_full(@_) }
sub bluestem_log      { $bsc->log(@_) }
sub bluestem_random   { $bsc->generate_clientkey() }

sub cookie_read {
	my($cacheid,$clientkey,$paservers) = $bsc->read_sessioncookies()
		or return '';
	return "$cacheid~$clientkey" if $cacheid and $clientkey;
}

1;
